任意门:http://acm.hdu.edu.cn/showproblem.php?pid=2795
Billboard
Time Limit: 20000/8000 MS (Java/Others) Memory Limit: 32768/32768 K (Java/Others)
Total Submission(s): 28743 Accepted Submission(s): 11651
On September 1, the billboard was empty. One by one, the announcements started being put on the billboard.
Each announcement is a stripe of paper of unit height. More specifically, the i-th announcement is a rectangle of size 1 * wi.
When someone puts a new announcement on the billboard, she would always choose the topmost possible position for the announcement. Among all possible topmost positions she would always choose the leftmost one.
If there is no valid location for a new announcement, it is not put on the billboard (that's why some programming contests have no participants from this university).
Given the sizes of the billboard and the announcements, your task is to find the numbers of rows in which the announcements are placed.
The first line of the input file contains three integer numbers, h, w, and n (1 <= h,w <= 10^9; 1 <= n <= 200,000) - the dimensions of the billboard and the number of announcements.
Each of the next n lines contains an integer number wi (1 <= wi <= 10^9) - the width of i-th announcement.
2
4
3
3
3
2
1
3
-1
题意概括:
有一个 高为H 宽为W 的公告墙,要在上面贴 N 个 高恒为1 宽为 W 的广告(每次都是优先左上方向),输出广告贴的高度 h;
解题思路:
线段树的子节点维护 1~H 每一层的所剩的最大值 Wi,每次查询不是找最大值,而是找到最大值所在的结点位置(第几层)
Tip:模板是死的,数据结构是活的。
Push操作从叶子结点往上更新;
线段树最大的边界不一定是输入的 H ,也可能是 N(极限每一层只贴一个)
但用min会超时很多,淳朴的 if 语句判断 H 还是 N 小就好
查询先遍历左子树后遍历右子树,因为优先贴左边。
看似简单的东西要自己亲手去敲代码才能发现问题所在。
AC code:
#include <bits/stdc++.h>
#define lson l, mid, root<<1
#define rson mid+1, r, root<<1|1
using namespace std; const int MAXN = 2e5+;
int maxh[MAXN<<], hb;
int H, W, N;
int read()
{
int f=,x=;char s=getchar();
while(s<''||s>''){if(s=='-')f=-;s=getchar();}
while(s>=''&&s<=''){x=x*+s-'';s=getchar();}
x*=f;
return x;
}
void Build(int l, int r, int root)
{
maxh[root] = W;
if(l == r) return;
//int mid = l+((r-l)>>1);
int mid = (l+r)>>;
Build(lson);Build(rson);
}
void Push(int Root)
{
maxh[Root] = max(maxh[Root<<], maxh[Root<<|]);
} void Update(int pos, int l, int r, int root, int len)
{
if(l == r){maxh[root]+=len;return;}
//int mid = l+((r-l)>>1);
int mid = (l+r)>>;
if(pos <= mid) Update(pos, lson, len);
else Update(pos, rson, len);
Push(root);
}
int Query(int l, int r, int root)
{
if(l == r) return l;
int mid = (l+r)>>;
int res = ;
if(maxh[root<<] >= hb) res = Query(lson);
else res = Query(rson);
return res;
}
int main()
{
while(~scanf("%d %d %d", &H, &W, &N)){
if(H > N) H = N;
Build(, H, );
for(int i = ; i <= N; i++)
{
hb = read();
//scanf("%d", &hb);
if(maxh[] < hb) printf("-1\n");
else{
int now = Query(, H, );
Update(now, , H, , -hb);
printf("%d\n", now);
}
}
}
return ;
}